## src main

=== Makefile ===
#
#
# The common user-driven targets are (for a complete list, see build(7)):
#
# universe            - *Really* build *everything* (buildworld and
#                       all kernels on all architectures).  Define
#                       MAKE_JUST_KERNELS or WITHOUT_WORLDS to only build kernels,
#                       MAKE_JUST_WORLDS or WITHOUT_KERNELS to only build userland.
# tinderbox           - Same as universe, but presents a list of failed build
#                       targets and exits with an error if there were any.
# worlds	      - Same as universe, except just makes the worlds.
# kernels	      - Same as universe, except just makes the kernels.
# buildworld          - Rebuild *everything*, including glue to help do
#                       upgrades.
# installworld        - Install everything built by "buildworld".
# world               - buildworld + installworld, no kernel.
# buildkernel         - Rebuild the kernel and the kernel-modules.
# installkernel       - Install the kernel and the kernel-modules.
# installkernel.debug
# reinstallkernel     - Reinstall the kernel and the kernel-modules.
# reinstallkernel.debug
# kernel              - buildkernel + installkernel.
# kernel-toolchain    - Builds the subset of world necessary to build a kernel
# kernel-toolchains   - Build kernel-toolchain for all universe targets.
# doxygen             - Build API documentation of the kernel, needs doxygen, TeX, and graphviz.
# checkworld          - Run test suite on installed world.
# check-old           - List obsolete directories/files/libraries.
# check-old-dirs      - List obsolete directories.
# check-old-files     - List obsolete files.
# check-old-libs      - List obsolete libraries.
# delete-old          - Delete obsolete directories/files.
# delete-old-dirs     - Delete obsolete directories.
# delete-old-files    - Delete obsolete files.
# delete-old-libs     - Delete obsolete libraries.
# list-old-dirs       - Raw list of possibly obsolete directories.
# list-old-files      - Raw list of possibly obsolete files.
# list-old-libs       - Raw list of possibly obsolete libraries.
# targets             - Print a list of supported TARGET/TARGET_ARCH pairs
#                       for world and kernel targets.
# toolchains          - Build a toolchain for all world and kernel targets.
# makeman             - Regenerate src.conf(5)
# sysent              - (Re)build syscall entries from syscalls.master.
# xdev                - xdev-build + xdev-install for the architecture
#                       specified with TARGET and TARGET_ARCH.
# xdev-build          - Build cross-development tools.
# xdev-install        - Install cross-development tools.
# xdev-links          - Create traditional links in /usr/bin for cc, etc
# native-xtools       - Create host binaries that produce target objects
#                       for use in qemu user-mode jails.  TARGET and
#                       TARGET_ARCH should be defined.
# native-xtools-install
#                     - Install the files to the given DESTDIR/NXTP where
#                       NXTP defaults to /nxb-bin.
#
# This makefile is simple by design. The FreeBSD make automatically reads
# the /usr/share/mk/sys.mk unless the -m argument is specified on the
# command line. By keeping this makefile simple, it doesn't matter too
# much how different the installed mk files are from those in the source
# tree. This makefile executes a child make process, forcing it to use
# the mk files from the source tree which are supposed to DTRT.
#
# Most of the user-driven targets (as listed above) are implemented in
# Makefile.inc1.  The exceptions are universe, tinderbox and targets.
#
# If you want to build your system from source, be sure that /usr/obj has
# at least 6 GB of disk space available.  A complete 'universe' build of
# r340283 (2018-11) required 167 GB of space.  ZFS lz4 compression
# achieved a 2.18x ratio, reducing actual space to 81 GB.
#
# For individuals wanting to build from the sources currently on their
# system, the simple instructions are:
#
# 1.  `cd /usr/src'  (or to the directory containing your source tree).
# 2.  Define `HISTORICAL_MAKE_WORLD' variable (see README).
# 3.  `make world'
#
# For individuals wanting to upgrade their sources (even if only a
# delta of a few days):
#
#  1.  `cd /usr/src'       (or to the directory containing your source tree).
#  2.  `make buildworld'
#  3.  `make buildkernel KERNCONF=YOUR_KERNEL_HERE'     (default is GENERIC).
#  4.  `make installkernel KERNCONF=YOUR_KERNEL_HERE'   (default is GENERIC).
#       [steps 3. & 4. can be combined by using the "kernel" target]
#  5.  `reboot'        (in single user mode: boot -s from the loader prompt).
#  6.  `etcupdate -p'
#  7.  `make installworld'
#  8.  `etcupdate -B'
#  9.  `make delete-old'
# 10.  `reboot'
# 11.  `make delete-old-libs' (in case no 3rd party program uses them anymore)
#
# For individuals wanting to build from source with GCC from ports, first
# install the appropriate GCC cross toolchain package:
#   `pkg install ${TARGET_ARCH}-gccN`
#
# Once you have installed the necessary cross toolchain, simply pass
# CROSS_TOOLCHAIN=${TARGET_ARCH}-gccN while building with the above steps,
# e.g., `make buildworld CROSS_TOOLCHAIN=amd64-gcc13`.
#
# The ${TARGET_ARCH}-gccN packages are provided as flavors of the
# devel/freebsd-gccN ports.
#
# See src/UPDATING `COMMON ITEMS' for more complete information.
#
# If TARGET=machine (e.g. powerpc64, arm64, ...) is specified you can
# cross build world for other machine types using the buildworld target,
# and once the world is built you can cross build a kernel using the
# buildkernel target.
#
# Define the user-driven targets. These are listed here in alphabetical
# order, but that's not important.
#
# Targets that begin with underscore are internal targets intended for
# developer convenience only.  They are intentionally not documented and
# completely subject to change without notice.
#
# For more information, see the build(7) manual page.
#

# Include jobs.mk early if we need it.
# It will turn:
# 	make buildworld-jobs
# into
# 	make -j${JOB_MAX} buildworld > ../buildworld.log 2>&1
#
.if make(*-jobs)
.include <jobs.mk>
.endif

.if defined(UNIVERSE_TARGET) || defined(MAKE_JUST_WORLDS) || defined(WITHOUT_KERNELS)
__DO_KERNELS=no
.endif
.if defined(MAKE_JUST_KERNELS) || defined(WITHOUT_WORLDS)
__DO_WORLDS=no
.endif
__DO_WORLDS?=yes
__DO_KERNELS?=yes

# This is included so CC is set to ccache for -V, and COMPILER_TYPE/VERSION can
# be cached for sub-makes. The need for CC is done with new make later in the
# build, and caching COMPILER_TYPE/VERSION is only an optimization. Also
# sinclude it to be friendlier to foreign OS hosted builds.
.sinclude <bsd.compiler.mk>

# Note: we use this awkward construct to be compatible with FreeBSD's
# old make used in 10.0 and 9.2 and earlier.
.if defined(MK_DIRDEPS_BUILD) && ${MK_DIRDEPS_BUILD} == "yes" && \
    !make(showconfig) && !make(print-dir)
# targets/Makefile plays the role of top-level
.include "targets/Makefile"
.else

.include "${.CURDIR}/share/mk/bsd.compat.pre.mk"

TGTS=	all all-man buildenv buildenvvars buildetc buildkernel buildworld \
	check check-old check-old-dirs check-old-files check-old-libs \
	checkdpadd checkworld clean cleandepend cleandir cleankernel \
	cleanworld cleanuniverse \
	delete-old delete-old-dirs delete-old-files delete-old-libs \
	depend distribute distributekernel distributekernel.debug \
	distributeworld distrib-dirs distribution doxygen \
	everything hier hierarchy install installcheck installetc installkernel \
	installkernel.debug packagekernel packageworld \
	reinstallkernel reinstallkernel.debug \
	installworld kernel-toolchain libraries maninstall \
	list-old-dirs list-old-files list-old-libs \
	obj objlink showconfig tags toolchain \
	makeman sysent \
	_cleanworldtmp _worldtmp _legacy _bootstrap-tools _cleanobj _obj \
	_build-tools _build-metadata _cross-tools _includes _libraries \
	builddtb xdev xdev-build xdev-install \
	xdev-links native-xtools native-xtools-install stageworld stagekernel \
	stage-packages stage-packages-kernel stage-packages-world stage-packages-source \
	create-packages-world create-packages-kernel \
	create-packages-kernel-repo create-packages-world-repo \
	create-packages-source create-packages \
	installconfig real-packages real-update-packages \
	sign-packages package-pkg print-dir test-system-compiler test-system-linker \
	test-includes

.for libcompat in ${_ALL_libcompats}
TGTS+=	build${libcompat} distribute${libcompat} install${libcompat}
.endfor

# These targets require a TARGET and TARGET_ARCH be defined.
XTGTS=	native-xtools native-xtools-install xdev xdev-build xdev-install \
	xdev-links

# XXX: r156740: This can't work since bsd.subdir.mk is not included ever.
# It will only work for SUBDIR_TARGETS in make.conf.
TGTS+=	${SUBDIR_TARGETS}

BITGTS=	files includes
BITGTS:=${BITGTS} ${BITGTS:S/^/build/} ${BITGTS:S/^/install/}
TGTS+=	${BITGTS}

# Only some targets are allowed to use meta mode.  Others get it
# disabled.  In some cases, such as 'install', meta mode can be dangerous
# as a cookie may be used to prevent redundant installations (such as
# for WORLDTMP staging).  For DESTDIR=/ we always want to install though.
# For other cases, such as delete-old-libs, meta mode may break
# the interactive tty prompt.  The safest route is to just whitelist
# the ones that benefit from it.
META_TGT_WHITELIST+= \
	_* buildfiles buildincludes buildkernel \
	buildworld everything kernel-toolchain kernel-toolchains kernel \
	kernels libraries native-xtools showconfig test-includes \
	test-system-compiler test-system-linker tinderbox toolchain \
	toolchains universe universe-toolchain world worlds xdev xdev-build

.for libcompat in ${_ALL_libcompats}
META_TGT_WHITELIST+=	build${libcompat}
.endfor

.ORDER: buildworld installworld
.ORDER: buildworld distrib-dirs
.ORDER: buildworld distribution
.ORDER: buildworld distribute
.ORDER: buildworld distributeworld
.ORDER: buildworld buildkernel
.ORDER: buildworld packages
.ORDER: buildworld update-packages
.ORDER: distrib-dirs distribute
.ORDER: distrib-dirs distributeworld
.ORDER: distrib-dirs installworld
.ORDER: distribution distribute
.ORDER: distributeworld distribute
.ORDER: distributeworld distribution
.ORDER: installworld distribute
.ORDER: installworld distribution
.ORDER: installworld installkernel
.ORDER: buildkernel installkernel
.ORDER: buildkernel installkernel.debug
.ORDER: buildkernel reinstallkernel
.ORDER: buildkernel reinstallkernel.debug
.ORDER: buildkernel packages
.ORDER: buildkernel update-packages
.ORDER: kernel-toolchain buildkernel

# Only sanitize PATH on FreeBSD.
# PATH may include tools that are required to cross-build
# on non-FreeBSD systems.
.if ${.MAKE.OS} == "FreeBSD"
PATH=	/sbin:/bin:/usr/sbin:/usr/bin
.endif
MAKEOBJDIRPREFIX?=	/usr/obj
_MAKEOBJDIRPREFIX!= /usr/bin/env -i PATH=${PATH:Q} ${MAKE} MK_AUTO_OBJ=no \
    ${.MAKEFLAGS:MMAKEOBJDIRPREFIX=*} __MAKE_CONF=${__MAKE_CONF} \
    SRCCONF=${SRCCONF} SRC_ENV_CONF= \
    -f /dev/null -V MAKEOBJDIRPREFIX dummy
.if !empty(_MAKEOBJDIRPREFIX) || !empty(.MAKEOVERRIDES:MMAKEOBJDIRPREFIX)
.error MAKEOBJDIRPREFIX can only be set in environment or src-env.conf(5),\
    not as a global (in make.conf(5) or src.conf(5)) or command-line variable.
.endif

# We often need to use the tree's version of make to build it.
.if !empty(.MAKE.MODE:Mmeta)
# 20160604 - support missing-meta,missing-filemon and performance improvements
WANT_MAKE_VERSION= 20160604
.else
# 20160220 - support .dinclude for FAST_DEPEND.
WANT_MAKE_VERSION= 20160220
.endif
.if defined(MYMAKE)
.error MYMAKE cannot be overridden, use as command name instead
.endif
MYMAKE=		${OBJROOT}make.${MACHINE}/bmake
.if defined(ALWAYS_BOOTSTRAP_MAKE) || \
    (defined(WANT_MAKE_VERSION) && ${MAKE_VERSION} < ${WANT_MAKE_VERSION})
NEED_MAKE_UPGRADE= t
.endif
.if defined(NEED_MAKE_UPGRADE)
. if exists(${MYMAKE})
