=== bin/df/Makefile ===
PACKAGE=runtime

PROG=	df
SRCS=	df.c

LIBADD=	xo util

.include <bsd.prog.mk>
