=== bin/kenv/Makefile ===
PACKAGE=runtime
PROG=	kenv

.include <bsd.prog.mk>
